# Cluster settings
cluster.name: "{{ elasticsearch_cluster_name }}"
discovery.type: "{% if (groups[target_hosts] | length) > 1 %}multi-node{% else %}single-node{% endif %}"
discovery.seed_hosts:
{% for host in groups[target_hosts ~ '-master'] %}
  - {{ host }}
{% endfor %}
action.auto_create_index: "true"
{% if elasticsearch_first_install %}
cluster.initial_master_nodes:
{% for host in groups[target_hosts ~ '-master'] %}
  - {{ host }}
{% endfor %}
{% endif %}

# Node settings
node.name: "{{ inventory_hostname }}"
node.roles: {{ elasticsearch_node_roles }}
network.bind_host: "0.0.0.0"
network.publish_host: "{{ hostvars[inventory_hostname].ansible_default_ipv4.address }}"
http.port: {{ elasticsearch_api_port }}
# https://www.elastic.co/guide/en/elasticsearch/reference/current/modules-network.html
http.compression: "{{ elasticsearch_http_compression | lower }}"
transport.port: {{ elasticsearch_transport_port }}
bootstrap.memory_lock: "true"
indices.cache.cleanup_interval: "1m"

# Security settings
xpack.security.enabled: "true"

# API
xpack.security.authc.api_key.enabled: "true"

# Transport
xpack.security.transport.ssl.client_authentication: "required"
xpack.security.transport.ssl.enabled: "true"
xpack.security.transport.ssl.verification_mode: "certificate"
xpack.security.transport.ssl.certificate_authorities: [ "/usr/share/elasticsearch/config/certificates/ca-certificate.crt" ]
xpack.security.transport.ssl.certificate: "/usr/share/elasticsearch/config/certificates/{{ inventory_hostname }}.crt"
xpack.security.transport.ssl.key: "/usr/share/elasticsearch/config/certificates/{{ inventory_hostname }}.key"

# HTTP
xpack.security.http.ssl.client_authentication: "{{ elasticsearch_http_authentication }}"
xpack.security.http.ssl.enabled: "true"
{% if elasticsearch_http_authentication in ['required', 'optional'] %}
xpack.security.http.ssl.certificate_authorities: [ "/usr/share/elasticsearch/config/certificates/ca-certificate.crt" ]
xpack.security.http.ssl.certificate: "/usr/share/elasticsearch/config/certificates/{{ inventory_hostname }}.full.crt"
xpack.security.http.ssl.key: "/usr/share/elasticsearch/config/certificates/{{ inventory_hostname }}.key"
{% endif %}